/* ANTI PATTERN
   works, but does not carry over to more
   interesting critical section examples,
   neither to systems where atomicity is
   an inappropriate assumption */

bool P_in_CS = false;
bool Q_in_CS = false;

active proctype P() {
  do
    :: printf("P non-critical actions\n");
       atomic{
         P_in_CS = true;
         /* begin critical section */
         printf("P uses shared resourses\n");
         assert( !Q_in_CS );
         /* end critical section */
         P_in_CS = false
      }
  od
}

active proctype Q() {
  do
    :: printf("Q non-critical actions\n");
       atomic{
         Q_in_CS = true;
         /* begin critical section */
         printf("Q uses shared resourses\n");
         assert( !P_in_CS );
         /* end critical section */
         Q_in_CS = false
       }
  od
}
